﻿using System;
using System.Data;

namespace Chop.Game.Catalogue
{
    public class CatalogueDeal
    {
        public int mProductID;
        public int mTemplateID;
        public int mItemCount;

        public static CatalogueDeal Parse(DataRow row)
        {
            var deal = new CatalogueDeal
                                     {
                                         mProductID = Convert.ToInt32(row["id"]),
                                         mTemplateID = Convert.ToInt32(row["tid"]),
                                         mItemCount = Convert.ToInt32(row["amount"])
                                     };


            return deal;
        }

        public string ToFuseString()
        {
            var fBuilder = new ResponseBuilder();
            ItemTemplate dealTemplate = Core.CatalogueManager.GetItem(mTemplateID);

            fBuilder.AppendString(dealTemplate.Sprite);
            fBuilder.AppendInt32(mItemCount);
            fBuilder.AppendString(dealTemplate.Colour);

            return fBuilder.ToString();
        }
    }
}
