﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Chop.Database;

namespace Chop.Game.Rooms
{
    public class RoomTemplateManager
    {
        public List<RoomTemplate> mTemplates;
        public List<RoomTrigger> mTriggers;

        public RoomTemplateManager()
        {
            mTemplates = new List<RoomTemplate>();
            mTriggers = new List<RoomTrigger>();
        }
        public void Init()
        {
            DataTable dTable;

            using (DatabaseClient dbClient = Core.DatabaseManager.GetClient())
                dTable = dbClient.ReadDataTable("SELECT * FROM room_modeldata");

            foreach (DataRow dRow in dTable.Rows)
                mTemplates.Add(RoomTemplate.Parse(dRow));

            using (DatabaseClient dbClient = Core.DatabaseManager.GetClient())
                dTable = dbClient.ReadDataTable("SELECT * FROM room_modeldata_triggers");

            foreach (DataRow dRow in dTable.Rows)
                mTriggers.Add(RoomTrigger.Parse(dRow));
        }
        public RoomTemplate GetTemplate(string pID)
        {
            foreach (RoomTemplate template in mTemplates)
                if (template.ModelName == pID)
                    return template;

            return null;
        }
        public List<RoomTrigger> GetTriggers(string pModelName)
        {
            List<RoomTrigger> triggers = new List<RoomTrigger>();

            foreach (RoomTrigger trigger in mTriggers)
                if (trigger.mModelName == pModelName)
                    triggers.Add(trigger);

            return triggers;
        }
    }
}
