using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Chop.Database;
using Chop.Game.Messages.IDs;

namespace Chop.Game.Messages.Incoming.navigator
{
    class CreateFlatMessageComposer: IMessageHandler
    {
        public void Handle(GameClient client, RequestParser parser)
        {
            // TODO: Swear check + others
            int id;
            string name = parser.ReadString();
            string model = parser.ReadString();

            // Do the magic here
            using (DatabaseClient dbClient = Core.DatabaseManager.GetClient())
            {
                dbClient.AddParamWithValue("name", name);
                dbClient.AddParamWithValue("model", model);
                dbClient.AddParamWithValue("owner", client.mHabbo.mName);

                dbClient.ExecuteQuery("INSERT INTO rooms(name,owner,state,model,showowner) VALUES(@name,@owner,'0',@model,'1')");
                id = dbClient.ReadInt32("SELECT MAX(id) FROM rooms WHERE owner = @owner");
            }
            if(id > 0)
            {
                ResponseBuilder message = new ResponseBuilder(OutgoingMessages.FlatCreatedEvent);
                message.AppendInt32(id);
                message.AppendString(name);
                client.SendMessage(message);
            }
        }
    }
}