using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Chop.Game.Messages.IDs;
namespace Chop.Game.Messages.Incoming.room.chat
{
    class WhisperMessageComposer: IMessageHandler
    {
        public void Handle(GameClient client, RequestParser parser)
        {
            string text = parser.ReadString();
            string recipient = text.Substring(0, text.IndexOf(' '));
            string messageText = Core.BobbaFilter.FilterText(text.Substring(recipient.Length + 1));

            if (!client.mRoom.ContainsUser(recipient))
                return;

            ResponseBuilder message = new ResponseBuilder(OutgoingMessages.WhisperMessageEvent);
            message.AppendInt32(client.mRoomUser.mDynamicID);
            message.AppendString(messageText);
            message.AppendInt32(1); // TODO: gesture

            message.AppendInt32(0); // link count
            //message.AppendString("http://google.no");
            //message.AppendString("http://google.no");
            //message.AppendBoolean(false); // link is local?
            //message.AppendString("http://google.se");
            //message.AppendString("http://google.se");
            //message.AppendBoolean(false); // link is local?

            message.AppendInt32(1); // trackingId

            // Send message to both sender and receiver
            Core.ClientManager.GetClientByHabbo(recipient).SendMessage(message);
            client.SendMessage(message);
        }
    }
}