#ifndef ROOM_H
#define ROOM_H

#include <QObject>
#include <QTimer>
#include <QHash>
#include "furniture.h"
#include "furnitureprofile.h"


class Client;

class Room : public QObject
{
    Q_OBJECT
public:
    enum Filter {
        NoFilter,
        NoEchoFilter, // DOesn't send back to sender
        AdminFilter
    };

    static Room* byID(int);
    static bool loadCheck(int);
    static void unload(int);

    inline bool isValid(){return valid;}
    inline QString getModel(){return model;}
    inline int getID(){return id;}
    inline int capacity(){return maxcount;}
    inline int size(){return clients.size();}
    int** heightmap;
    inline int** getHeightMap(){return heightmap;}
    QList<Client*> listClients(Filter = NoFilter, Client* = 0);
    QHash<int, Furniture*> furnituremap;

signals:

public slots:
    void broadcastPacket(QString, Filter = NoFilter, Client* sender=NULL);
    Client* getClientById(int);
    void cleanup();

private:
    friend class Client;

    static QHash<int, Room*> loaded_rooms;

    int id; // colored differently?
    bool valid;
    QString title;
    QString desc;
    QString ownerstr;
    int category;
    QString model;
    int showowner;
    int maxcount;
    int doorx;
    int doory;
    int oid;
    QString doorh;

    Room(int id);
    QTimer unloader;
    QList<Client*> clients;
    void enterRoom(Client*);
    void leaveRoom(Client*); // brb
    void updateHeightMap(bool);
    void unload();
    virtual ~Room();

};

#endif // ROOM_H
