﻿/*
Thor Server 2.0 Project - Codenamed "Stockholm"
Copyright 2008 - 2009 Joe Hegarty


This file is part of The Thor Server 2.0 Project - Codenamed "Stockholm".

The Thor Server 2.0 Project - Codenamed "Stockholm" is free software: you can 
redistribute it and/or modify it under the terms of the Microsoft Public License

The Thor Server Project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Microsoft Public License for more details.

You should have received a copy of the Microsoft Public License
along with The Thor Server Project.  If not, see 
http://www.opensource.org/licenses/ms-pl.html
*/

using System;
using System.Collections.Generic;

using StockholmLibrary.Net;


namespace StockholmLibrary.Game.Sessions
{
    //------------------------------------
    public class SessionManager
    {
        private Dictionary<Peer, Session> _sessionList = new Dictionary<Peer, Session>();
        private object _sessionListLock = new object();

        //**********************************************
        public Session GetSession(Peer peer)
        {
            lock (_sessionListLock)
            {
                if (_sessionList.ContainsKey(peer))
                {
                    return _sessionList[peer];
                }
            }

            return null;
        }

        //**********************************************
        public void AddSession(Session session)
        {
            lock (_sessionListLock)
            {
                _sessionList.Add(session.Peer, session);
            }
        }
    }
}
