﻿/*
Thor Server 2.0 Project - Codenamed "Stockholm"
Copyright 2008 - 2009 Joe Hegarty


This file is part of The Thor Server 2.0 Project - Codenamed "Stockholm".

The Thor Server 2.0 Project - Codenamed "Stockholm" is free software: you can 
redistribute it and/or modify it under the terms of the Microsoft Public License

The Thor Server Project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Microsoft Public License for more details.

You should have received a copy of the Microsoft Public License
along with The Thor Server Project.  If not, see 
http://www.opensource.org/licenses/ms-pl.html
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StockholmLibrary.Util
{
    //------------------------------------
    public class IsometricPoint
    {
        public int X, Y;
        public float Z;

        //**********************************************
        public IsometricPoint()
        {
            this.X = 0;
            this.Y = 0;
            this.Z = 0;
        }

        //**********************************************
        public IsometricPoint(int x, int y)
        {
            this.X = x;
            this.Y = y;
            this.Z = 0;
        }

        //**********************************************
        public IsometricPoint(int x, int y, float z)
        {
            this.X = x;
            this.Y = y;
            this.Z = z;
        }

        //**********************************************
        public override int GetHashCode()
        {
            return X.GetHashCode() ^ Y.GetHashCode();
        }

        //**********************************************
        public void Copy(IsometricPoint obj)
        {
            this.X = obj.X;
            this.Y = obj.Y;
            this.Z = obj.Z;
        }

        //**********************************************
        public string ToCreatureLocationString()
        {
            return X + " " + Y + " " + Z;
        }
    }
}
